// 3DIY (3d-diy.ru)
// управление
// 1 кнопка >1 сек - парковка, >5 сек выравнивание
// 2 кнопка >1 сек - установка часов: 1 кнопка смена цифры, 2 кнопка подтверждение, последняя цифра - запись с 00 сек


#include <TM1637Display.h>
#include <Wire.h>
#include "ds3231.h"

// первый
#define DATA_PIN_1    2//0
#define LATCH_PIN_1   4//1 
#define CLOCK_PIN_1   3//2 
// второй
#define DATA_PIN_2    5//0 
#define LATCH_PIN_2   7//1 
#define CLOCK_PIN_2   6//2 

#define BUT1        A0 
#define BUT2        A1 
#define Msteppers   12

#define CLK 9//A4
#define DIO 8//A5

byte cd = 0;

TM1637Display display(CLK, DIO);
struct ts t;

#define itSinh 3600                
volatile unsigned long sSinh = 0; 
struct its {
  uint8_t sec;
  uint8_t min;
  uint8_t hour;
  uint8_t wday;
};
struct its it;


#define timeSens 100 
#define BLD 3000   
#define incr 5     
byte flag_B1D; 
byte flag_B1U; 
byte flag_B1LD; 
byte flag_B2D; 
byte flag_B2U;  
byte flag_B2LD;
byte flag_B2SU; 
byte maxDig[4] = {2, 9, 5, 9}; 

const byte DP[] = { 
  0b00000000,
  0b01011110,
  0b01110011,
  0b00000000,
};

byte drive[6] = {    
  0b00001001,
  0b00001000,
  0b00000010,
  0b00000110,
  0b00000100,
  0b00000001
};

/*byte drive[6] = {    
  0b00000001,
  0b00000100,
  0b00000110,
  0b00000010,
  0b00001000,
  0b00001001
  };*/

struct stepper {
  byte stepA = 0;     
  byte stepB = 0;     
  byte revA = 0;      
  byte revB = 0;     
  byte ok = 0;       
  byte absGrA = 90;        
  byte absGrB = 90;      
  byte setGrA = 90;   
  byte setGrB = 90;         
  byte comb = 0x00;      
  byte oldComb;
  byte oldRevB;
  byte oldRevA;
  byte st = 0;

  void setGr(byte A, byte B) {   
    setGrB = B;
    setGrA = A;
    //if (!ok) return;
    byte a;
    if ((absGrA > setGrA)) {
      a = (absGrA - setGrA);
      if (a > 90) {
        stepA = 180 - a;
        revA = 0;
      } else {
        stepA = a;
        revA = 1;
      }
    } else if (setGrA > absGrA) {
      a = (setGrA - absGrA);
      if (a > 90) {
        stepA = 180 - a;
        revA = 1;
      } else {
        stepA = a;
        revA = 0;
      }
    }
    if ((absGrB > setGrB)) {
      a = (absGrB - setGrB);
      if (a > 90) {
        stepB = 180 - a;
        revB = 0;
      } else {
        stepB = a;
        revB = 1;
      }
    } else if (setGrB > absGrB) {
      a = (setGrB - absGrB);
      if (a > 90) {
        stepB = 180 - a;
        revB = 1;
      } else {
        stepB = a;
        revB = 0;
      }
    }
    if (oldRevB != revB) stepB++; 
    //   if (oldRevA != revA) stepA++; 
    absGrA = setGrA;
    absGrB = setGrB;
    oldRevB = revB;
    oldRevA = revA;
    ok = 0;
  }

  void go() {
    comb = 0x00;
    //    static byte st = 0;         
    if (ok) {
      comb = oldComb;
      return;
    }
    if (!stepA && !stepB) {   
      st = 0;
      ok = 1;
      comb = oldComb;
      return;
    }
    byte stA = revA ? st : 5 - st;
    byte stB = revB ? 5 - st : st;
    if (!stepA) stA = 5;
    if (!stepB) stB = 5;
    comb = drive[stB] | (drive[stA] << 4);
    oldComb = comb;
    if (st == 5) {
      st = 0;
      stepA = !stepA ? 0 : stepA - 1;
      stepB = !stepB ? 0 : stepB - 1;
    } else {
      st++;
    }
  }
};


stepper STEP_1[Msteppers]; 
stepper STEP_2[Msteppers];

#define maxPoz  11
unsigned long pozS[12] = {135135, 135135, 135135, 45045, 45045, 45045, 135135, 135135, 135135, 45045, 45045, 45045};
unsigned int BITime_1[12] = {45, 30, 12, 27, 59, 15, 22, 33, 87, 42, 74};
unsigned int BITime_2[12] = {01, 23, 34, 56, 78, 90, 12, 11, 68, 23, 00};
unsigned long poz[maxPoz][6] = {
  135090, 90000, 135, 45, 90000, 45090,     
  45045, 45045, 45045, 0, 90, 67090,           
  135135, 135090, 135, 45045, 45, 45090,      
  135135, 135135, 135135, 45, 90, 45090,       
  90090, 135, 45045, 0, 90, 90090,           
  135090, 135000, 135135, 45, 45090, 45045,    
  135090, 90, 135, 45, 45090, 45045,           
  135135, 45045, 45045, 0, 90, 45090,        
  135112, 157090, 135, 45, 22090, 45067,       
  90135, 135, 135135, 45, 90, 45090,        
  90090, 90090, 90090, 90090, 90090, 90090,  
};

byte rej = 0;   
byte Scalibr[12] = {30, 30, 30, 150, 150, 150, 30, 30, 30, 150, 150, 150};
byte Rcalibr[12] = {44, 44, 45, 135, 135, 136, 44, 44, 45, 135, 135, 136};  
byte Sstop; 


void setup() {
  DDRD = 0b11111111;
  delay(500);
  pinMode(BUT1, INPUT);
  pinMode(BUT2, INPUT);
  Wire.begin();
  DS3231_init(DS3231_INTCN);
  cli();
  TCCR1A = 0;       
  OCR1A = 0x3D08;       
  TCCR1B = 0b00001101;  
  TIMSK1 = 0b00000010; 
  sei();
  //Serial.begin(9600);
  //Serial.println("S");
  display.setBrightness(7);
  display.setSegments(DP);       
  delay(1000);
  readT();
  flags_null();
}


void loop() {
  calibr();
  goGr();
  driver();
  edit();
  sensitive();                  
  vClock();                    
  if (sSinh > itSinh) readT(); 
  park();
  level();
}

void level() {
  static long timer;
  static byte rej_1 = 0;
  if (flag_B2U && flag_B2D) {
  //  Serial.println("R");
    rej = 5;
    flags_null();
  }
  if (rej != 5) return;
  if (rej_1 == 0) {
    for (byte i = 0; i < Msteppers; i++) {
      STEP_1[i].stepA = 180;
      STEP_1[i].stepB = 180;
      STEP_2[i].stepA = 180;
      STEP_2[i].stepB = 180;
      STEP_1[i].ok = 0;
      STEP_2[i].ok = 0;
      if (i == 0 or i == 1 or i == 2 or i == 6 or i == 7 or i == 8) {
        STEP_1[i].revA = 1;
        STEP_1[i].revB = 1;
        STEP_2[i].revA = 1;
        STEP_2[i].revB = 1;
      } else {
        STEP_1[i].revA = 0;
        STEP_1[i].revB = 0;
        STEP_2[i].revA = 0;
        STEP_2[i].revB = 0;
      }
    }
    timer = millis() + 15000;
    rej_1 = 1;
  //  Serial.println("B");
  }
  if (rej_1 == 1) {
    if (timer < millis()) {
  //    Serial.println("-");
      rej_1 = 0;
      for (byte i = 0; i < Msteppers; i++) {
        STEP_1[i].ok = 1;
        STEP_2[i].ok = 1;
      }
      cd = 1;
      rej = 0;  
    }
  }
}

void park() {
  static byte rej_1 = 10;
  if (flag_B2LD) {
    rej = 3;
    flags_null();
  }
  if (rej != 3)return;
  if (rej_1 == 10) {
    if (Mstop() == Msteppers * 2) { 
      delay(100);
      rej_1 = 0;
    }
  }
  if (rej_1 == 0) {
    for (byte i = 0; i < Msteppers; i++) {
      byte a = pozS[i] / 1000;
      byte b = pozS[i] % 1000;
      STEP_1[i].setGr(a, b);
      STEP_2[i].setGr(a, b);
    }
    byte data[4];
    data[0] = 0b00000000;          
    data[1] = display.encodeDigit(0);
    data[2] = display.encodeDigit(0xf);
    data[3] = display.encodeDigit(0xf);
    display.setSegments(data);
    delay(200);
    rej_1 = 1;
  } else if (rej_1 == 1) {
    if (Mstop() == Msteppers * 2) {
      delay(100);
      rej_1 = 2;
    }
  } else if (rej_1 == 2) {
    for (byte i = 0; i < Msteppers; i++) {
      STEP_1[i].setGr(90, 90);
      STEP_2[i].setGr(90, 90);
    }
    rej_1 = 3;
  } else if (rej_1 == 3) {
    if (Mstop() == Msteppers * 2) {
      while (1);
    }
  }

}

void edit() {
  static byte dig = 0;  
  static unsigned long timer;
  static byte mig = 0;
  static byte old2;
  static byte td[4];  
  static byte te[4];
  static byte flag_2;
  if (flag_B1LD) {
    td[3] = it.min % 10;
    td[2] = it.min / 10;
    td[1] = it.hour % 10;
    td[0] = it.hour / 10;
    old2 = td[1];
    flags_null();
    dig = 0;
    rej = 2;
  }
  if (rej != 2) return;
  if (timer > millis()) return;
  for (byte i = 0; i < 4; i++) {
    te[i] = display.encodeDigit(td[i]);
    if (!mig && i == dig) te[i] = 0 & 0x0f; // display.encodeDigit(16);
  }
  display.setSegments(te);
  mig = !mig;
  if (flag_B2D) {
    td[dig] = td[dig] >= maxDig[dig] ? 0 : td[dig] + 1;
    // Serial.println(td[dig]);
    if (dig == 0 && td[0] == 2) { 
      maxDig[1] = 3;
      td[1] = td[1] % 3;
      flag_2 = 1;
    } else {
      maxDig[1] = 9;
      if (flag_2) { 
        td[1] = old2;
        flag_2 = 0;
      }
    }
    flags_null();
  }
  if (flag_B1D) { 
    dig++;
    flags_null();
    if (dig > 3) {
      t.min = td[2] * 10 + td[3];
      t.hour = td[0] * 10 + td[1];
      t.sec = 0;
      DS3231_set(t);
      readT();
      dispTime();
      rej = 1;
    }
  }
  timer = millis() + 50;
  //  flags_null();
  //  rej = 0;
}

void sensitive () { 
  static unsigned long timerS;
  static byte fb1[2];
  static byte fb2[2];
  static byte ldB1; 
  static byte ldB2; 
  if (timerS > millis()) return;
  fb1[1] = fb1[0];
  fb1[0] = digitalRead(BUT1);
  fb2[1] = fb2[0];
  fb2[0] = digitalRead(BUT2);
  if (fb1[0] && !fb1[1]) flag_B1U = 1;
  if (!fb1[0] && fb1[1]) flag_B1D = 1;
  if (fb2[0] && !fb2[1]) flag_B2U = 1;
  if (!fb2[0] && fb2[1]) flag_B2D = 1;
  if (!fb1[0] && !fb1[1]) {
    ldB1++;
    if (ldB1 > (BLD / timeSens)) flag_B1LD = 1;
  } else {
    ldB1 = 0;
  }
  if (!fb2[0] && !fb2[1]) {
    ldB2++;
    if (ldB2 > (BLD / timeSens)) flag_B2LD = 1;
  } else {
    ldB2 = 0;
    //    flag_B2SU = 1; 
  }
  timerS = millis() + timeSens;
}

void flags_null() {
  flag_B1D = 0;
  flag_B1U = 0;
  flag_B1LD = 0;
  flag_B2D = 0;
  flag_B2U = 0;
  flag_B2LD = 0;
  flag_B2SU = 0;
  //  rej = 1;
}

void vClock() {                   
  static byte oldMin;
  if (rej == 2 or rej == 0 or rej == 5) return;      
  if (it.min == oldMin) return;
  dispTime();
  // goGr();
  rej = 1; 
  oldMin = it.min;
}

void dispTime() { 
  int timer = it.hour * 100 + it.min;
  display.showNumberDec(timer, true);
  Serial.println(timer);
}

void readT() {
  DS3231_get(&t);
  cli();
  it.sec = t.sec;
  it.min = t.min;
  it.hour = t.hour;
  it.wday = t.wday;
  TCNT1 = 0;
  sei();
  sSinh = 0;
}

void calibr() {
  static unsigned long timer;
  static byte a = 0;
  static byte rej_1 = 0; 
  //  if (timer < millis()) rej = 0;
  if (rej != 0) return;
  if (cd)rej_1 = 1;
  if (rej_1 == 0) {
    Serial.println("C");
    for (byte i = 0; i < Msteppers; i++) {
      STEP_1[i].setGr(Scalibr[i], Scalibr[i]);
      STEP_2[i].setGr(Scalibr[i], Scalibr[i]);
    }
    rej_1 = 1;
  } else if (rej_1 == 1) {
    if (Mstop() == Msteppers * 2) {
      delay(200);
      for (byte i = 0; i < Msteppers; i++) {
        STEP_1[i].absGrA = Rcalibr[i];
        STEP_1[i].absGrB = Rcalibr[i];// + (i < 3 ? -1 : +1); 
        STEP_1[i].setGr(90, 90);
        STEP_2[i].absGrA = Rcalibr[i];
        STEP_2[i].absGrB = Rcalibr[i];// + (i < 3 ? -1 : +1); 
        STEP_2[i].setGr(90, 90);
      }
      cd = 0;
      rej_1 = 2;
    }
  } else if (rej_1 == 2) {
    if (Mstop() == Msteppers * 2) {
      delay(1000);
      rej_1 = 0;
      rej = 1;
      flags_null();
    }
  }
  //  timer = millis()+20000;
}

void goGr() {            
  static byte rej_1 = 0;  
  if (rej != 1) return;
  static byte pr = 0;
  //  static unsigned long timer;
  byte a, b;
  //  if (timer > millis()) return;
  if (rej_1 == 0) {
    for (byte i = 0; i < Msteppers; i++) {
      a = pozS[i] / 1000;
      b = pozS[i] % 1000;
      STEP_1[i].setGr(a, b);
      STEP_2[i].setGr(a, b);
    }
    rej_1 = 1;
  } else if (rej_1 == 1) {
    if (Mstop() == Msteppers * 2) rej_1 = 2;
  } else if (rej_1 == 2) {
    for (byte i = 0; i < Msteppers; i++) {
      if (i < 6) {                          
        a = poz[it.hour / 10][i] / 1000;
        b = poz[it.hour / 10][i] % 1000;
      } else {
        a = poz[it.hour % 10 - 1][i] / 1000;
        b = poz[it.hour % 10 - 1][i] % 1000;
      }
      STEP_1[i].setGr(a, b);
      if (i < 6) {                        
        a = poz[it.min / 10][i] / 1000;
        b = poz[it.min / 10][i] % 1000;
      } else {
        a = poz[it.min % 10 - 1][i] / 1000;
        b = poz[it.min % 10 - 1][i] % 1000;
      }
      STEP_2[i].setGr(a, b);
    }
    pr = pr == maxPoz ? 0 : pr + 1;
    rej_1 = 0;
    rej = 4;
    //Serial.println(pr);
    //    timer = millis() + 6000;
  }
}

void driver() {
  static byte st = 0;                   
  static unsigned long timer;
  if ((timer + 5) > millis()) return; 
  //  PORTB = 1;
  byte sti = 0;
  if (st == 0) {
    for (byte i = 0; i < Msteppers; i++) {
      STEP_1[i].go(); 
      if (!STEP_1[i].ok) sti = 1;
    }
    if (sti) {
      PDdigWL(LATCH_PIN_1);         
      for (byte i = 0; i < Msteppers; i++) {
        writeByteP_1(STEP_1[i].comb);
      }
      PDdigWH(LATCH_PIN_1);          
    }
  } else {
    for (byte i = 0; i < Msteppers; i++) {
      STEP_2[i].go();
      if (!STEP_2[i].ok) sti = 1;
    }
    if (sti) {
      PDdigWL(LATCH_PIN_2);       
      for (byte i = 0; i < Msteppers; i++) {
        writeByteP_2(STEP_2[i].comb);
      }
      PDdigWH(LATCH_PIN_2);        
    }
  }
  st = !st;
  delayMicroseconds(100);
  timer = millis();
  //  PORTB = 0;
}

byte Mstop() {  
  byte a = 0;
  for (byte i = 0; i < Msteppers; i++) {
    a = a + STEP_1[i].ok;
  }
  for (byte i = 0; i < Msteppers; i++) {
    a = a + STEP_2[i].ok;
  }
  return a;
}


inline void writeByteP_1(byte byteW) {    
  for (int i = 0; i <= 7; i++)
  {
    if (bitRead(byteW, i)) {
      PDdigWH(DATA_PIN_1);
    } else {
      PDdigWL(DATA_PIN_1);
    }
    PDdigWH(CLOCK_PIN_1);
    PDdigWL(CLOCK_PIN_1);
  }
}
inline void writeByteP_2(byte byteW) {  
  for (int i = 0; i <= 7; i++)
  {
    if (bitRead(byteW, i)) {
      PDdigWH(DATA_PIN_2);
    } else {
      PDdigWL(DATA_PIN_2);
    }
    //  delayMicroseconds(20);
    PDdigWH(CLOCK_PIN_2);
    PDdigWL(CLOCK_PIN_2);
  }
}

inline void PDdigWH(byte NB) {
  PORTD |= 1 << NB;
}
inline void PDdigWL(byte NB) {
  PORTD &= ~(1 << NB);
}

ISR(TIMER1_COMPA_vect) {
  sSinh++;
  it.sec++;
  if (it.sec < 60) return;
  it.sec = 0;
  it.min++;
  if (it.min < 60) return;
  it.min = 0;
  it.hour++;
  if (it.hour < 24) return;
  it.hour = 0;
  it.wday++;
  if (it.wday < 8) return;
  it.wday = 0;
}
